var bricks = window.bricks || {};

bricks.Popup = class extends bricks.VBox {
	/*
	{
		timeout:0
		auto_open:
		archor:one of ['tl', 'tc', 'tr', 'cl', 'cc', 'cr', 'bl','bc', 'br']
		widget:null for bricks.Body, string value for widget's id or a widget object;
		auto_dismiss:
	*/
	constructor(opts){
		super(opts);
		this.auto_task = null;
		this.issub = false;
		this.set_css('popup');
		const zindex = bricks.app.new_zindex();
		this.set_style('zIndex', zindex);
		if (this.auto_dismiss){
			bricks.Body.bind('click', this.click_outside.bind(this));
		}
	}
	click_outside(event){
		if (event.target != this.dom_element){
			this.dismiss();
		}
	}
	add_widget(w, index){
		super.add_widget(w, index);
		if (this.auto_open){
			this.open();
		}
	}
	transform2screen_at(rect, lt){
		var screen_rect = bricks.Body.showRectage();
		top = rect.top + parseInt(lt.y) / 100 * rect.height;
		left = rect.left + parseInt(lt.x) / 100 * rect.width;
		return {
			top:top + 'px',
			left:left + 'px'
		}
	}
	convert_width(){
		
	}
	open(){
		var rect;

		if (this.widget instanceof bricks.JsWidget){
			rect = this.widget.showRectage()
			this.issub = true;
		} else if (this.widget instanceof String){
			var w = bricks.getWidgetById(this.widget, bricks.Body);
			if (!w){
				ithis.issub = true
				rect = bricks.Body.showRectage();
			}
		} else {
			rect = bricks.Body.showRectage();
		}
		var lt = archor_at(this.archor);
		if (this.issub){
			lt = this.transform2screen_at(rect, lt);
			if (this.width && this.width.endsWith('%')){
				this.set_style('width', parseFloat(rect.width) * parseFloat(this.width) + 'px');
			}
			if (this.height && this.height.endsWith('%')){
				this.set_style('height', parseFloat(rect.height) * parseFloat(this.height) + 'px');
			}
		}
		this.set_style('top',lt.top);
		thos.set_style('left',lt.left);
		this.set_style('display', 'block');
		if (this.timeout > 0){
			this.auto_task = schedule_once(this.auto_dismiss.bind(this), this.timeout)
		}
	}
	dismiss(){
		if (this.auto_task){
			this.auto_task.cancel();
			this.auto_task = null;
		}
		this.set_style('display','none');
	}
}

bricks.Factory.register('Popup', bricks.Popup);
